import java.awt.Frame;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class UE20Aufgabe12 {

	public static void main(String[] args) {
		java.awt.Frame f = new Frame("MenuTest");
		MenuBar mb = new MenuBar();
		f.setMenuBar(mb);

		Menu fileM = new Menu("File");
		fileM.add(new MenuItem("New"));
		fileM.add(new MenuItem("Open"));
		fileM.add(new MenuItem("Save"));
		fileM.add(new MenuItem("Exit"));

		MyMenuItem callsItem = new MyMenuItem("Calls = ");
		fileM.add(callsItem);
		callsItem.addActionListener(new CallsListener(callsItem));

		mb.add(fileM);

		Menu windowM = new Menu("Window");
		windowM.add(new MenuItem("New Window"));

		Menu toolsM = new Menu("Tools");
		toolsM.add(new MenuItem("Editor"));
		toolsM.add(new MenuItem("Debugger"));
		toolsM.add(new MenuItem("Compiler"));

		windowM.add(toolsM);

		windowM.add(new MenuItem("Preferences..."));
		mb.add(windowM);

		f.pack();
		f.setVisible(true);
	}

}

class MyMenuItem extends MenuItem {

	String praefix;
	int calls;

	MyMenuItem(String p) {
		this.praefix = p;
		this.calls = 0;
		this.setLabel(this.praefix + this.calls);
	}

	void incrCalls() {
		this.calls++;
		this.setLabel(this.praefix + this.calls);
	}

}

class CallsListener implements ActionListener {

	MyMenuItem item;

	CallsListener(MyMenuItem i) {
		this.item = i;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		this.item.incrCalls();
	}
}
