import iodemo.IOListener;
import iodemo.IOObject;
import iodemo.MButton;
import iodemo.MFrame;

public class IODemo {

	public static void main(String[] args) {
		MFrame fenster = new MFrame();
		fenster.addIOListener(new MFrameListener());
		MButton button = new MButton("B 1");
		fenster.add(button);
		MButtonListener bListener = new MButtonListener(button);
		button.addIOListener(bListener);
	}

}

class MButtonListener implements IOListener {

	MButton button;

	MButtonListener(MButton b) {
		button = b;
	}

	@Override
	public void inputEntered(IOObject obj) {
		System.out.println("Button " + button.getName() + " Eingabewert = "
				+ obj.getValue());

	}

}

class MFrameListener implements IOListener {
	
	@Override
	public void inputEntered(IOObject obj) {
		System.out.println("Fenster " + " Eingabewert = "
				+ obj.getValue());

	}
}
